#ifndef SHORTCUTINTERFACE_H
#define SHORTCUTINTERFACE_H

#include "universalinterface.h"
#include "getshortcutworker.h"
#include "type.h"
#include <QObject>
#include <QtDBus>
#include <QMap>

class ShortcutInterface : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.ukui.ukcc.session.Shortcut")

public:
    ShortcutInterface();
    ~ShortcutInterface();

public Q_SLOTS:
    QList<QStringPair> getSystemShortcut();
    QList<QStringPair> getCustomShortcut();
    QList<KeyEntry>    getSystemShortcutEntry();
    QList<KeyEntry>    getCustomShortcutEntry();

    void               updateShortcut();
    void               setSystemShortcut(const QString &key, const QString &value);

private:
    QList<KeyEntry>    systemEntries;
    QList<KeyEntry>    customEntries;
    QList<QStringPair> systemShortcutList;
    QList<QStringPair> customShortcutList;

private:
    void getShortcutThread();
    QMap<QString, QString> MergerOfTheSamekind(QMap<QString, QString> desktopMap);
    void buildGeneralWidget(QString schema, QMap<QString, QString> subShortcutsMap);
    QString getShowShortcutString(QString src);

Q_SIGNALS:
    void changed(QString key);
};

#endif // SHORTCUTINTERFACE_H
